<img src="https://content.arduino.cc/website/Arduino_logo_teal.svg" height="100" align="right" />

# Arduino_OplaUI

[![Check Arduino status](https://github.com/arduino-libraries/Arduino_OplaUI/actions/workflows/check-arduino.yml/badge.svg)](https://github.com/arduino-libraries/Arduino_OplaUI/actions/workflows/check-arduino.yml)
[![Compile Examples](https://github.com/arduino-libraries/Arduino_OplaUI/workflows/Compile%20Examples/badge.svg)](https://github.com/arduino-libraries/Arduino_OplaUI/actions?workflow=Compile+Examples)
[![Spell Check](https://github.com/arduino-libraries/Arduino_OplaUI/workflows/Spell%20Check/badge.svg)](https://github.com/arduino-libraries/Arduino_OplaUI/actions?workflow=Spell+Check)
[![Unit Tests](https://github.com/arduino-libraries/Arduino_OplaUI/workflows/Unit%20Tests/badge.svg)](https://github.com/arduino-libraries/Arduino_OplaUI/actions?workflow=Unit+Tests)
[![codecov](https://codecov.io/gh/arduino-libraries/Arduino_OplaUI/branch/master/graph/badge.svg)](https://codecov.io/gh/arduino-libraries/Arduino_OplaUI)
[![License](https://img.shields.io/github/license/arduino-libraries/Arduino_OplaUI)](https://support.arduino.cc/hc/en-us/articles/360018434279-I-have-used-Arduino-for-my-project-do-I-need-to-release-my-source-code-)

This Arduino library provides user interface helpers and widgets for the [Arduino Oplà IoT](https://store.arduino.cc/opla-iot-kit) Kit and the [MKR IoT Carrier](http://store.arduino.cc/mkr-iot-carrier).

With this library you can use the features of the device (round display, colored LEDs, buzzer and touch buttons) to create an interactive user interface.

Features:

* 4 styles of gauges
* widget framework that makes it easy to combine multiple independent widgets in a single application (gauge, string, bool)
* use touch buttons to increase/decrease values

> See the [library home page](https://www.arduino.cc/reference/en/libraries/servo/) and the [examples](examples/) for more information about this library and its usage.

## 🔎 Resources

* [How to install a library](https://www.arduino.cc/en/guide/libraries)
* [Help Center](https://support.arduino.cc/)
* [Forum](https://forum.arduino.cc)

## 🐛 Bugs & Issues

If you want to report an issue with this library, you can submit it to the [issue tracker](issues) of this repository. Remember to include as much detail as you can about your hardware set-up, code and steps for reproducing the issue. Make sure you're using an original Arduino board.

## 👨‍💻 Development

There are many ways to contribute:

* Improve documentation and examples
* Fix a bug
* Test open Pull Requests
* Implement a new feature
* Discuss potential ways to improve this library

You can submit your patches directly to this repository as Pull Requests. Please provide a detailed description of the problem you're trying to solve and make sure you test on real hardware.

## 💛 Donations

This open-source code is maintained by Arduino with the help of the community. We invest a considerable amount of time in testing code, optimizing it and introducing new features. Please consider [donating](https://www.arduino.cc/en/donate/) or [sponsoring](https://github.com/sponsors/arduino) to support our work, as well as [buying original Arduino boards](https://store.arduino.cc/) which is the best way to make sure our effort can continue in the long term.